import { Disposable } from './disposable.interface';
import { OnDestroy } from '@angular/core';
import { Destructor } from './destructor.type';
import { Observable, Subscription } from 'rxjs';
export declare class Cycler implements Disposable, OnDestroy {
    private _destructors;
    private _transientDestructors;
    /**
     * Disposes the Cycler causing all it's dependant managed
     * entities to be disposed. This method will be called
     * automatically by Angular if the Cycler is properly
     * provided.
     */
    dispose(): void;
    ngOnDestroy(): void;
    manage(dependency: Destructor | Disposable | Subscription): Disposable;
    manageDestructor(destructor: Destructor): Disposable;
    manageDisposable(disposable: Disposable): Disposable;
    manageTransient(code: string, destructor: Destructor): Disposable;
    manageSubscription(subscription: Subscription): Disposable;
    manageTransientSubscription(code: string, subscription: Subscription): Disposable;
    manageSubscriptions(...subscriptions: Subscription[]): void;
    managedSubscribe<T>(observable: Observable<T>, next: (value: T) => void): Disposable;
}
